<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

    <xsl:template match="/">
	    	<xsl:apply-templates select="category"/>
    </xsl:template>
    
    <xsl:template match="category">
    	<HTML>
    	<BODY>
    		<H1>Period <I><xsl:value-of select="@name"/></I></H1> 
    		<xsl:for-each select="path">
    			<a>
    				<xsl:attribute name="href">period_<xsl:value-of select="@id"/>.html</xsl:attribute>
	    			<xsl:value-of select="@name"/>
	    		</a>
    			<xsl:text>.</xsl:text>
    		</xsl:for-each><xsl:value-of select="@name"/>
    		<P/>
    		<table cellpadding="4">
    			<tr><th align="left">From</th> <td><I><xsl:value-of select="@from"/></I> (<xsl:value-of select="@from-msec"/>)</td></tr> 
    			<tr><th align="left">To </th> <td><I><xsl:value-of select="@to"/></I> (<xsl:value-of select="@to-msec"/>)</td></tr>
    			<tr><th align="left">Min </th> <td><I><xsl:value-of select="@min"/></I></td></tr>
    			<tr><th align="left">Avg </th> <td><I><xsl:value-of select="@avg"/></I></td></tr>
    			<tr><th align="left">Max </th> <td><I><xsl:value-of select="@max"/></I></td></tr>
    			<tr><th align="left">Total </th> <td><I><xsl:value-of select="@total"/></I></td></tr>
    			<tr><th align="left">Measurements </th> <td><I><xsl:value-of select="@measurements"/></I></td></tr>
    			<tr><th align="left">Deviation </th> <td><I><xsl:value-of select="@deviation"/></I></td></tr>
    			<tr><th align="left">Length </th> <td><I><xsl:value-of select="@length"/></I></td></tr>
    		</table>
 
    		<xsl:if test="category">
    			<h2>Subcategories</h2>
    			<table border="1" cellspacing="0" cellpadding="4">
    				<tr bgcolor="yellow">
    					<th>#</th>    				
    					<th>Name</th>
		    			<th>Min</th>
		    			<th>Avg</th>
		    			<th>Max</th>
		    			<th>Total</th>
		    			<th>Measurements</th>
		    			<th>Deviation</th>
		    			<th>%</th>
    				</tr>
		    		<xsl:for-each select="category">
		    			<tr>
			    			<td align="right"><xsl:value-of select="position()"/></td>
			    			<td>
			    				<a>
			    					<xsl:attribute name="href">period_<xsl:value-of select="@id"/>.html</xsl:attribute>
				    				<xsl:value-of select="@name"/>
				    			</a>
			    			</td>
			    			<td align="right"><xsl:value-of select="@min"/></td>
			    			<td align="right"><xsl:value-of select="@avg"/></td>
			    			<td align="right"><xsl:value-of select="@max"/></td>
			    			<td align="right"><xsl:value-of select="@total"/></td>
			    			<td align="right"><xsl:value-of select="@measurements"/></td>
			    			<td align="right"><xsl:value-of select="@deviation"/></td>
			    			<td align="right"><xsl:value-of select="@pct"/></td>
			    		</tr>
		    		</xsl:for-each>
	    		</table>
	    	</xsl:if>
	    	
 			<h2>Composite chart</h2>   		
    		<img>
    			<xsl:attribute name="src">main_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
    		</img>
    		
 			<h2>Average chart</h2>   		
    		<img>
    			<xsl:attribute name="src">average_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
    		</img>
    		
 			<h2>Intensity chart</h2>   		
    		<img>
    			<xsl:attribute name="src">intensity_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
    		</img>
    		
 			<h2>Total chart</h2>   		
    		<img>
    			<xsl:attribute name="src">total_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
    		</img>
    		
    		<h2>Slices</h2>
			<table border="1" cellspacing="0" cellpadding="4">
				<tr bgcolor="yellow">
					<th>#</th>    				
	    			<th>Min</th>
	    			<th>Avg</th>
	    			<th>Max</th>
	    			<th>Total</th>
	    			<th>Measurements</th>
	    			<th>Deviation</th>
	    			<th>From</th>
	    			<th>To</th>
	    			<th>Length</th>
				</tr>
	    		<xsl:for-each select="slice">
	    			<tr>
		    			<td align="right"><xsl:value-of select="position()"/></td>
		    			<td align="right"><xsl:value-of select="MIN_VALUE"/></td>
		    			<td align="right"><xsl:value-of select="@avg"/></td>
		    			<td align="right"><xsl:value-of select="MAX_VALUE"/></td>
		    			<td align="right"><xsl:value-of select="TOTAL"/></td>
		    			<td align="right"><xsl:value-of select="MEASUREMENTS"/></td>
		    			<td align="right"><xsl:value-of select="DEVIATION"/></td>
		    			<td align="right"><xsl:value-of select="TIME_FROM"/></td>
		    			<td align="right"><xsl:value-of select="TIME_TO"/></td>
		    			<td align="right"><xsl:value-of select="@length"/></td>
		    		</tr>
	    		</xsl:for-each>
    		</table>
    		
    		<P/>
    		
    		<xsl:if test="count(category)>1">	
    			<h2>Subcategories charts</h2>
    	
	 			<h3>Averages chart</h3>   		
	    		<img>
	    			<xsl:attribute name="src">childrenAverage_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
	    		</img>
	    		
	 			<h3>Intensities chart</h3>   		
	    		<img>
	    			<xsl:attribute name="src">childrenIntensity_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
	    		</img>
	    		
	 			<h3>Totals chart</h3>   		
	    		<img>
	    			<xsl:attribute name="src">childrenTotal_<xsl:value-of select="@id"/>.jpg</xsl:attribute>
	    		</img>
	    	</xsl:if>
    		
	    </BODY>
	    </HTML>
    </xsl:template>
    
</xsl:stylesheet>