/*
@license.text@
 */
package com.pavelvlasov.eval.samples;

import java.io.PrintWriter;
import java.io.Reader;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;

import biz.hammurapi.config.MapContext;
import biz.hammurapi.eval.ExpandingFilterWriter;


/**
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class ExpandingFilterWriterSample {

	public static void main(String[] args) throws Exception {
		Map ctx=new HashMap();
		ctx.put("a", "Super");
		ctx.put("b", "${a}-duper");
		ctx.put("c", "${d}-duper");
		ctx.put("d", "${c}-duper");
		
        MapContext context = new MapContext(ctx);
        
		Reader r=ExpandingFilterWriter.expand(new StringReader("It's real ${b}, $${a} - ${z}"), context);
        char[] buf=new char[1024];
        int i;
        while ((i=r.read(buf))!=-1) {
        	String str = new String(buf, 0, i);
			System.out.println(str);
        }		
		
//        Uncomment next line to get CircularReferenceException
//        System.out.println(ExpandingFilterWriter.expandToString(new StringReader("${c}!"), context));
        
        ExpandingFilterWriter efw=new ExpandingFilterWriter(
                new PrintWriter(System.out), 
                context);
        
        efw.write("Simple ${a}, $${a} - ${z}");
        efw.close();
        
	}
}
