/*
@license.text@
 */
package com.pavelvlasov.metrics.sample;

import java.util.Random;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import biz.hammurapi.metrics.MeasurementCategoryFactory;
import biz.hammurapi.metrics.MeasurementConsumer;

/**
* This program demonstrates indirect usage of MeasurementSinks 
* through MeasurementSinkFactory.
* It produces random metrics with random interval and stores 
* them to a database.
* @author Pavel Vlasov
*
* @version $Revision$
*/
public class Boot {
	static {
        BasicConfigurator.configure();
        Logger.getRootLogger().setLevel(Level.INFO);        
	}
	
	private static final MeasurementConsumer measurementSink=MeasurementCategoryFactory.getCategory(Boot.class);

	public static void main(String[] args) throws Exception {		
	    Random random=new Random(System.currentTimeMillis() ^ Boot.class.hashCode());
		for (int i=0; i<1000; i++) {			
			double rValue = i<250 ? 0 : 0.2*Math.random()*Math.sin(i/50.0)+Math.cos(i/100.0);
			long currentTimeMillis = System.currentTimeMillis();
//			System.out.println(i+"["+currentTimeMillis+"] -> "+rValue);
			measurementSink.addMeasurement("SimpleMetric", rValue, currentTimeMillis);
			if (rValue<0.7) {
			    measurementSink.addMeasurement("Metric 2", i/1000.0 + random.nextDouble()*Math.cos(i/300.0), currentTimeMillis);
			}
			Thread.sleep(random.nextInt(10)+1);
		}		
//		MeasurementCategoryFactory.shutdownBootSinks();
		System.out.println("Done");		
	}
}
