/*
@license.text@
 */
package com.pavelvlasov.util.samples;

import java.io.File;

import biz.hammurapi.util.PoliteVisitor;
import biz.hammurapi.xml.dom.DOMUtils;
import biz.hammurapi.xml.dom.DomVisitable;


/**
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class DomVisitableSample {

	public static void main(String[] args) throws Exception {
		new DomVisitable(DOMUtils.parse(new File(args[0]))).accept(
				new PoliteVisitor() {
					int level;

					public boolean visit(Object target) {
						for (int i=0; i<level; i++) {
							System.out.print("\t");
						}
						System.out.println("> "+target.getClass().getName()+": "+target);
						level++;
						return true;
					}

					public void leave(Object target) {
						level--;
						for (int i=0; i<level; i++) {
							System.out.print("\t");
						}
						System.out.println("< "+target.getClass().getName());
					}										
					
				});
	}
}
