/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi;

/**
 * This exception adds "root cause" throwable class and message to its message
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class Exception extends java.lang.Exception {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 9056009202942745656L;

	public Exception() {
		super();
	}

	public Exception(String message) {
		super(message);
	}

	public Exception(String message, Throwable cause) {
		// TODO Switch to select 1.3 or 1.4
		super(message+rootCause(cause), cause);
	}

	public Exception(Throwable cause) {
		// TODO Switch to select 1.3 or 1.4
		super(rootCause(cause), cause);
	}
	
	static String rootCause(Throwable cause) {
		while (cause!=null && cause.getCause()!=null && cause!=cause.getCause()) {
			cause=cause.getCause();
		}
		return cause==null ? "" : "\nRoot cause: "+cause.toString();
	}
}
