/*
 * Param.java
 *
 * Created on October 1, 2002, 11:01 AM
 */

package biz.hammurapi.ant;

import org.apache.tools.ant.BuildException;

/**
 * Parameter 
 * @ant.element name="parameter"
 * @author Pavel Vlasov	
 * @version $Revision: 1.2 $
 */
public class Param extends ObjectEntry {

	private String name=null;
    
	/**
	 * @ant.ignore
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * Parameter name.
	 * @ant.required
	 * @param name
	 */
	public void setName(String name) {
		this.name = name;
	}
    
    /**
     * Reads value from the property.
     */
    private String property=null;

	/**
	 * Property to get value from. Value will not be set if property is not set.
	 * Mutually exclusive with value and className
	 * @ant.non-required
	 * @param name
	 */
    public void setProperty(String property) {
        this.property=property;        
    }

    public Object getObject(ClassLoader masterClassLoader) throws BuildException {
        if (property!=null) {
        	if (getValue()!=null) {
        		throw new BuildException("property and value attributes are mutually exclusive");
        	}
        	
        	if (getClassName()!=null) {
        		throw new BuildException("property and className attributes are mutually exclusive");
        	}
        	
            return getProject()==null ? null : getProject().getProperty(property);            
        }
		return super.getObject(masterClassLoader);
    }
    
    public String getProperty() {
        return property;
    }
    
    public void execute() throws BuildException {
        if (name==null){
        	throw new BuildException("Name attribute is mandatory");
        }
        
        if (getValue()==null && property==null && getClassName()==null) {
        	throw new BuildException("Either value, property or className must be set");
        }
    }
}
