/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.config;


import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Simple container
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public abstract class DomConfigurableContainer extends GenericContainer implements DomConfigurable {
	public DomConfigurableContainer() {
		// Default constructor
	}
	
	protected abstract String getComponentName(Node node);

	public void configure(Node configNode, final Context context) throws ConfigurationException {
		DomConfigFactory factory=new DomConfigFactory(new Context() {

			public Object get(String name) {
				Object ret=DomConfigurableContainer.this.get(name);
				if (ret!=null) {
					return ret;
				}
				return context==null ? null : context.get(name);
			}
			
		});
		
		NodeList children=configNode.getChildNodes();
		for (int i=0, length=children.getLength(); i<length; i++) {
			Node child=children.item(i);
			if (child instanceof Element) {
				addComponent(getComponentName(child), factory.create(child));
			}
		}
	}
}
