package biz.hammurapi.config;

public interface RestartCommand extends Runnable {
	
	public static final String RESTART_DELARY_PROPERTY = RestartCommand.class.getName()+":restart-delay";
	
	public static final long DEFAULT_RESTART_DELAY = 5000;

	/**
	 * @return Number of times the command was already executed.
	 */
	int getAttempt();
	
	/**
	 * @return Number of milliseconds the command waits before creating
	 * and starting the object. The command waits only if number of attempts is 
	 * more than zero. The value is taken from the system property with the name
	 * specified in RESTART_DELAY_PROPERTY constant. Default restart delay is specified in
	 * DEFAULT_RESTART_DELAY constant.
	 */
	long getRestartDelay();
}
