/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.config;

import biz.hammurapi.RuntimeException;

/**
 * Wrapper for ConfigurationException for situations where it is
 * not possible to throw a checked exception.
 * @author Pavel Vlasov	
 * @version $Revision: 1.2 $
 */
public class RuntimeConfigurationException extends RuntimeException {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 6791750987717236849L;

	public RuntimeConfigurationException() {
		super();
	}

	/**
	 * @param message
	 */
	public RuntimeConfigurationException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public RuntimeConfigurationException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public RuntimeConfigurationException(String message, Throwable cause) {
		super(message, cause);
	}
}
