package biz.hammurapi.config;

/**
 * Service is a marker interface. It indicates component
 * which start() method can be invoked multiple times.
 * Component maintains internal isStarted flag to make sure that 
 * initialization sequence is executed only once. If one thread
 * is executing start() method and another thread enters
 * start() method, then the second thread shall be blocked until the
 * first thread finishes initialization. The first thread shall awaken
 * the second thread or threads once component is initialized.
 * If the same thread enters start() method recursively the component shall
 * throw ConfigurationException with a message "Circular dependency ...".
 * 
 * The naming bus invokes start() method of service instances before returning
 * them from get() method.
 * 
 * @author Pavel
 *
 */
public interface Service extends Component {

}
