/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.config.adapters;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.FileConfigurable;
import biz.hammurapi.config.InputStreamConfigurable;

/**
 * Converts {@link biz.hammurapi.config.InputStreamConfigurable} to {@link biz.hammurapi.config.FileConfigurable}
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class File2InputStreamConfigurableAdapter implements FileConfigurable {

	private InputStreamConfigurable isc;

	/**
	 * 
	 */
	public File2InputStreamConfigurableAdapter(InputStreamConfigurable isc) {
		super();
		this.isc=isc;
	}

	public void configure(File file, Context context) throws ConfigurationException {
		try {
			isc.configure(new FileInputStream(file), context);
		} catch (FileNotFoundException e) {
			throw new ConfigurationException(e);
		}
	}
}
