/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.config.adapters;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.DomConfigurable;
import biz.hammurapi.config.InputStreamConfigurable;

/**
 * Converts {@link biz.hammurapi.config.DomConfigurable} to {@link biz.hammurapi.config.InputStreamConfigurable}
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class InputStream2DomConfigurableAdapter implements InputStreamConfigurable {

	private DomConfigurable domConfigurable;

	/**
	 * 
	 */
	public InputStream2DomConfigurableAdapter(DomConfigurable domConfigurable) {
		super();
		this.domConfigurable=domConfigurable;
	}

	/* (non-Javadoc)
	 * @see biz.hammurapi.config.InputStreamConfigurable#configure(java.io.InputStream)
	 */
	public void configure(InputStream in, Context context) throws ConfigurationException {
		try {
			domConfigurable.configure(
				DocumentBuilderFactory
					.newInstance()
					.newDocumentBuilder()
					.parse(in)
					.getDocumentElement(), context);
		} catch (SAXException e) {
			throw new ConfigurationException(e);
		} catch (IOException e) {
			throw new ConfigurationException(e);
		} catch (ParserConfigurationException e) {
			throw new ConfigurationException(e);
		} catch (FactoryConfigurationError e) {
			throw new ConfigurationException(e);
		}		
	}

}
