/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.config.adapters;

import java.io.IOException;
import java.net.URL;

import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.InputStreamConfigurable;
import biz.hammurapi.config.URLConfigurable;

/**
 * Converts {@link biz.hammurapi.config.InputStreamConfigurable} to {@link biz.hammurapi.config.URLConfigurable}
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class URL2InputStreamConfigurableAdapter implements URLConfigurable {

	private InputStreamConfigurable isc;

	/**
	 * 
	 */
	public URL2InputStreamConfigurableAdapter(InputStreamConfigurable isc) {
		super();
		this.isc=isc;
	}

	/* (non-Javadoc)
	 * @see biz.hammurapi.config.URLConfigurable#configure(java.net.URL)
	 */
	public void configure(URL url, Context context) throws ConfigurationException {
		try {
			isc.configure(url.openStream(), context);
		} catch (IOException e) {
			throw new ConfigurationException(e);
		}
	}
}
