/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.eval;

import java.util.Collection;
import java.util.Iterator;

import biz.hammurapi.convert.CompositeConverter;


public class MultiResult extends Result {
	Collection values;
    private CompositeConverter converter;
	
	/**
	 * @param value
	 * @param type
	 */
	public MultiResult(Class type, Collection values, CompositeConverter converter) {
		super(type);
		this.values = values;
		this.converter=converter;
	}
	
	public Object[] getValues() {
	    Object[] ret=new Object[values==null ? 0 : values.size()];
	    if (values!=null) {
		    Iterator it=values.iterator();
		    for (int i=0; it.hasNext(); i++) {
		        ret[i] = type==null ? it.next() : converter.convert(it.next(), type, false);
		    }
	    }
	    return ret;
	}
	
	void setValues(Collection values) {
		this.values = values;
	}
}