package biz.hammurapi.jms;

import java.io.StringWriter;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.dom.DOMResult;

import org.w3c.dom.Document;

import biz.hammurapi.config.RuntimeConfigurationException;
import biz.hammurapi.xml.dom.DOMUtils;

public abstract class DomMessageProcessor extends StylingXmlMessageProcessor {
	
	protected Result createResult() {
		try {
			return new DOMResult(DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument());
		} catch (ParserConfigurationException e) {
			throw new RuntimeConfigurationException("Cannot create document: "+e, e);
		}
	}
	
	protected String processResult(Result result) {
		Document ret = processDocument((Document) ((DOMResult) result).getNode());
		if (ret==null) {
			return null;
		}
		
		try {
			StringWriter sw = new StringWriter();
//			XMLSerializer serializer = new XMLSerializer(sw, new OutputFormat("xml", "UTF-8", false));
//			serializer.setNamespaces(true);
//			serializer.serialize(ret);
			DOMUtils.serialize(ret, sw);
			sw.close();
			return sw.toString();
		} catch (Exception e) {
			throw new MessageProcessingException(e);
		}
	}

	protected abstract Document processDocument(Document document);

}
