/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.jms;

import java.io.PrintStream;
import java.io.PrintWriter;

import javax.jms.JMSException;

/**
 * Extension of JMSException to allow cause chaining.
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class JMSExceptionEx extends JMSException {
	private Throwable cause;
	
	public Throwable getCause() {
		return cause;
	}

	public JMSExceptionEx(String message) {
		super(message);
	}

	public JMSExceptionEx(String message, Throwable cause) {
		super(message);
		this.cause=cause;
	}

	public JMSExceptionEx(Throwable cause) {
		super("Caused by: "+cause);
		this.cause=cause;
	}
	
	public void printStackTrace() {
		super.printStackTrace();
		if (cause!=null) {
			System.err.println("=== NESTED EXCEPTION ===");
			cause.printStackTrace();
		}		
	}

	public void printStackTrace(PrintWriter p) {
		super.printStackTrace(p);
		if (cause!=null) {
			p.println("=== NESTED EXCEPTION ===");
			cause.printStackTrace(p);
		}				
	}

	public void printStackTrace(PrintStream p) {
		super.printStackTrace(p);
		if (cause!=null) {
			p.println("=== NESTED EXCEPTION ===");
			cause.printStackTrace(p);
		}				
	}	

}
