package biz.hammurapi.jms;

import java.io.StringWriter;

import javax.xml.transform.Result;

import org.apache.xmlbeans.XmlObject;

public abstract class XmlBeansMessageProcessor extends StylingXmlMessageProcessor {
	
	protected Result createResult() {
		return new XmlBeansSaxResult();
	}
	
	protected String processResult(Result result) {
		try {
			XmlObject ret = processObject(((XmlBeansSaxResult) result).getObject());
			if (ret==null) {
				return null;
			}
		
			StringWriter sw = new StringWriter();
			ret.save(sw);
			sw.close();
			return sw.toString();
		} catch (Exception e) {
			throw new MessageProcessingException(e);
		}
	}

	protected abstract XmlObject processObject(XmlObject obj);

}
