package biz.hammurapi.jms.adapter;

import javax.jms.ConnectionFactory;
import javax.jms.Destination;

import biz.hammurapi.config.Component;
import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Wrapper;

public class FactoryConnection extends JmsConnection implements DestinationResolver {

	private Object factory;

	public FactoryConnection(JmsAdapter jmsAdapter, biz.hammurapi.jms.adapter.definition.FactoryConnection definition) throws ConfigurationException {
		super(jmsAdapter, definition);
		factory = JmsAdapter.instantiate(definition.getFactory());
		if (factory instanceof Component) {
			((Component) factory).setOwner(this);
		}
	}

	public void start() throws ConfigurationException {
		if (factory instanceof Component) {
			((Component) factory).start();
		}
		super.start();
	}

	public void stop() throws ConfigurationException {
		super.stop();
		if (factory instanceof Component) {
			((Component) factory).stop();
		}
	}

	public Destination lookupDestination(String name) throws ConfigurationException {
		return ((DestinationResolver) (factory instanceof Wrapper ? ((Wrapper) factory).getMaster() : factory)).lookupDestination(name);
	}

	protected ConnectionFactory getConnectionFactory() throws ConfigurationException {
		return (ConnectionFactory) (factory instanceof Wrapper ? ((Wrapper) factory).getMaster() : factory);
	}

}
