package biz.hammurapi.jms.adapter.jca;

import java.io.Serializable;

import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.InvalidPropertyException;
import javax.resource.spi.ResourceAdapter;

/**
 * Associates message endpoint with listener.
 * @author Pavel
 *
 */
public class ActivationSpecImpl implements ActivationSpec, Serializable {

	private transient ResourceAdapter resourceAdapter;

	public void validate() throws InvalidPropertyException {
		if (listenerName==null) {
			throw new InvalidPropertyException("Listener is not set");
		}
	}
	
	private String listenerName;
	
	public String getListenerName() {
		return listenerName;
	}
	
	public void setListenerName(String listenerName) {
		this.listenerName = listenerName;
	}

	public ResourceAdapter getResourceAdapter() {
		return resourceAdapter;
	}

	public void setResourceAdapter(ResourceAdapter ra) throws ResourceException {
		this.resourceAdapter = ra;

	}

}
