package biz.hammurapi.jms.adapter.jca;

import javax.resource.ResourceException;

/**
 * Connection factory.
 * @author Pavel
 */
public interface ConnectionFactory {
	
	/**
	 * Stateful connection caches proxy instances and as such retains conversational state if
	 * proxy services use local delegates.
	 * @param stateful
	 * @return
	 * @throws ResourceException 
	 */
	Connection getConnection(boolean stateful) throws ResourceException;

	/**
	 * Creates stateful connection with pre-set state. 
	 * @param state State obtained from previously used connection.
	 * @return
	 * @throws ResourceException
	 */
	Connection getConnection(Object state) throws ResourceException;
}
