package biz.hammurapi.jms.adapter.jca;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;

/**
 * @author Pavel Vlasov
 */
public class ConnectionFactoryImpl implements ConnectionFactory {
	
	private ConnectionManager connectionManager;
	private ManagedConnectionFactoryImpl managedConnectionFactory;
	
	/**
	 * Constructor
	 */
	public ConnectionFactoryImpl(ManagedConnectionFactoryImpl managedConnectionFactory, ConnectionManager connectionManager) {
		super();
		this.managedConnectionFactory = managedConnectionFactory;
		this.connectionManager = connectionManager;
	}

	public Connection getConnection(boolean stateful) throws ResourceException {
		return (Connection) connectionManager.allocateConnection(managedConnectionFactory, managedConnectionFactory.new JmsConnectionRequestInfo(stateful));
	}

	public Connection getConnection(Object state) throws ResourceException {
		return (Connection) connectionManager.allocateConnection(managedConnectionFactory, managedConnectionFactory.new JmsConnectionRequestInfo(state));
	}
}