/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.legacy.persistence;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 * @author Pavel Vlasov
 * @version $Revision: 1.1 $
 */
public class FileStorage implements Storage {
	
	private File storageDir;

	public FileStorage(File storageDir) {
		this.storageDir=storageDir;
	}

	public String put(Object o) throws PersistenceException {
		if (o instanceof Serializable) {
			try {
				File file=File.createTempFile("storage", ".dat", storageDir);
				ObjectOutputStream oos=new ObjectOutputStream(new FileOutputStream(file));
				try {
					oos.writeObject(o);
				} finally {
					oos.close();
				}
				return file.getName();
			} catch (IOException e) {
				throw new PersistenceException(e);
			}
		} else {
			return null;
		}
	}

	public Object get(String key) throws PersistenceException {
		File file=new File(storageDir, key);
		try {
			ObjectInputStream ois=new ObjectInputStream(new FileInputStream(file));
			try {
				return ois.readObject();
			} finally {
				ois.close();
			}
		} catch (IOException e) {
			throw new PersistenceException(e);
		} catch (ClassNotFoundException e) {
			throw new PersistenceException(e);			
		}
	}

	public void remove(String key) throws PersistenceException {
		new File(storageDir, key).delete();
	}

}
