/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.legacy.review;

import java.io.Serializable;

/**
 * @author Pavel Vlasov
 * @version $Revision: 1.3 $
 */
public class SimpleSourceMarker implements SourceMarker, Signed, Comparable, Serializable {
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 8717158207915979L;
	private int column;
	private int line;
	private Integer id;
	
	/**
	 * @return Returns the id.
	 */
	public Integer getSourceId() {
		return id;
	}
	
	/**
	 * @param id The id to set.
	 */
	public void setSourceId(Integer id) {
		this.id = id;
	}
	private String sourceURL;
	private String signature;

	/**
	 * 
	 */
	public SimpleSourceMarker() {
		super();
	}

	/**
	 * @return Returns the column.
	 */
	public int getColumn() {
		return column;
	}

	/**
	 * @param column The column to set.
	 */
	public void setColumn(int column) {
		this.column = column;
	}

	/**
	 * @return Returns the line.
	 */
	public int getLine() {
		return line;
	}

	/**
	 * @param line The line to set.
	 */
	public void setLine(int line) {
		this.line = line;
	}

	/**
	 * @return Returns the sourceURL.
	 */
	public String getSourceURL() {
		return sourceURL;
	}

	/**
	 * @param sourceURL The sourceURL to set.
	 */
	public void setSourceURL(String sourceURL) {
		this.sourceURL = sourceURL;
	}

	/**
	 * @param column
	 * @param line
	 * @param sourceURL
	 */
	public SimpleSourceMarker(int column, int line, String sourceURL, Integer id) {
		super();
		this.column = column;
		this.line = line;
		this.sourceURL = sourceURL;
		this.id=id;
	}
	
	public SimpleSourceMarker(SourceMarker sourceMarker) {
		this.column=sourceMarker.getColumn();
		this.line=sourceMarker.getLine();
		this.sourceURL=sourceMarker.getSourceURL();
		this.id=sourceMarker.getSourceId();
		
		if (sourceMarker instanceof Signed) {
			this.signature=((Signed) sourceMarker).getSignature();
		}
	}

	public int compareTo(Object o) {
		if (o instanceof SourceMarker) {
			return SourceMarkerComparator._compare(this, o);
		} else {
			return 1;
		}
	}

	public String getSignature() {
		return signature;
	}

	public void setSignature(String signature) {
		this.signature = signature;
	}
}
