/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.legacy.review;

import java.util.Comparator;

/**
 * @author Pavel Vlasov
 * @version $Revision: 1.3 $
 */
public class SourceMarkerComparator implements Comparator {

	public static int _compare(Object o1, Object o2) {
		if (o1==null) {
			return o2==null ? 0 : 1;
		} else if (o2==null) {
			return -1;
		} else if (o1 instanceof SourceMarker && o2 instanceof SourceMarker) {
			SourceMarker sm1=(SourceMarker) o1;
			SourceMarker sm2=(SourceMarker) o2;
			int compareIds=_compare(sm1.getSourceId(), sm2.getSourceId());
			if (compareIds==0) {
				int compareSourceURLs=_compare(sm1.getSourceURL(), sm2.getSourceURL());
				if (compareSourceURLs==0) {
					return comparePosition(sm1, sm2);
				} else {
					return compareSourceURLs;
				}
			} else {
				return compareIds;
			}
		} else if (o1 instanceof Comparable) {
			return ((Comparable) o1).compareTo(o2);
		} else {
			throw new UnsupportedOperationException("Comparision of objects other than SourceMarker is not supported");
		}
	}
	

	private static int comparePosition(SourceMarker sm1, SourceMarker sm2) {
		if (sm1.getLine()==sm2.getLine()) {
			return sm1.getColumn()-sm2.getColumn();
		} else {
			return sm1.getLine()-sm2.getLine();
		}
	}

	public int compare(Object o1, Object o2) {
		return _compare(o1, o2);
	}
}
