/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.logging;

import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;

/**
 * @author Pavel Vlasov	
 * @version $Revision: 1.1 $
 */
public class AntLogger implements Logger {
	
	private Task task;

	public AntLogger(Task task) {
		this.task=task;
	}

	public void debug(Object source, String message) {
		task.log("["+source+"] "+message, Project.MSG_DEBUG);
	}

	public void verbose(Object source, String message) {
		task.log("["+source+"] "+message, Project.MSG_VERBOSE);
	}

	public void info(Object source, String message) {
		task.log("["+source+"] "+message, Project.MSG_INFO);
	}

	public void warn(Object source, String message) {
		task.log("["+source+"] "+message, Project.MSG_WARN);
	}

	public void error(Object source, String message) {
		task.log("["+source+"] "+message, Project.MSG_WARN);
	}
}
