/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz  
 */
package biz.hammurapi.metrics;

import java.util.Date;

import org.apache.log4j.Logger;

/**
 * @author Pavel Vlasov
 */
public class Log4jInfoSliceConsumer implements SliceConsumer {

		public boolean consumeSlice(String category, Slice slice) {
			StringBuffer msg=new StringBuffer(category);
			msg.append(": ");
			msg.append("Name="+slice.getName());
			msg.append("; Total="+slice.getTotal());
			msg.append("; Avg="+slice.getAvg());
			msg.append("; Min="+slice.getMin());
			msg.append("; Max="+slice.getMax());
			msg.append("; Deviation="+slice.getDeviation());
			msg.append("; From="+slice.getFrom()+" ("+new Date(slice.getFrom())+")");
			msg.append("; To="+slice.getTo()+" ("+new Date(slice.getTo())+")");
			msg.append("; Measurements="+slice.getNumber());
			Logger.getLogger(category).info(msg.toString());
			return true;
		}
}
