<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="inspectorsPath"/>

    <xsl:template match="/">       
        <HTML>
            <xsl:apply-templates select="/metric"/>
        </HTML>
    </xsl:template>
    
    <xsl:template match="metric">
        <HEAD>
            <TITLE>Metric details: <xsl:value-of select="@name"/></TITLE>
            <STYLE> 
            <xsl:text disable-output-escaping="yes">
                <![CDATA[<!-- ]]>
                    th { font:bold; background:gray }
                    table { background:silver }
                    tr { background:white }
            <![CDATA[ --> ]]>
            </xsl:text>
            </STYLE>
        </HEAD>                    
        <BODY>
        <H1>"<xsl:value-of select="@name"/>" metric details</H1>
        <B>Min: </B><xsl:value-of select="@min"/><BR/>
        <B>Avg: </B><xsl:value-of select="@avg"/><BR/>
        <B>Max: </B><xsl:value-of select="@max"/><BR/>
        <B>Total: </B><xsl:value-of select="@total"/><BR/>
        <B>Samples: </B><xsl:value-of select="@number"/><BR/>        
        
        <xsl:if test="measurement">
	        <B style="color:blue">Measurements</B>
	        <table border="0" cellspacing="1" cellpadding="3" class="standard">
	            <tr class="standard">
	                <th class="standard">#</th>
	                <th class="standard">Value</th>
	                <th class="standard">Source</th>
	            </tr>
	            <xsl:for-each select="measurement">
	                <tr class="standard">
	                    <td align='right'><xsl:value-of select="position()"/></td>
	                    <td align="right"><xsl:value-of select="@value"/></td>
	                    <td>
	                          	<xsl:choose>
	                          		<xsl:when test="not(source-marker/@source-url)"><xsl:value-of select="source"/></xsl:when>
	                          		
	                            <xsl:otherwise>
	                            <!--	              <xsl:variable name="dirName"><xsl:value-of select="translate(@name,'.','/')"/></xsl:variable> -->
	  	                            		                            
			                        <a>
			                            <xsl:attribute name="href">
											<xsl:value-of select="$inspectorsPath"/><xsl:value-of select="source-marker/@source-url"/>.html#line_<xsl:value-of select="source-marker/@line"/>		                            
										</xsl:attribute>
			                            <xsl:value-of select="source-marker/@source-url"/><xsl:text disable-output-escaping="yes"><![CDATA[&nbsp;]]></xsl:text><xsl:value-of select="source-marker/@line"/>:<xsl:value-of select="source-marker/@col"/>
			                        </a>
	                            </xsl:otherwise>
	                        </xsl:choose>
	                        
	                    </td>
	                </tr>                        
	            </xsl:for-each>
	        </table>
	    </xsl:if>
	    ${footer}
        </BODY>    
    </xsl:template>        
</xsl:stylesheet>
