/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.metrics;

import org.w3c.dom.Element;

import biz.hammurapi.render.RenderingException;
import biz.hammurapi.xml.dom.DOMUtils;
import biz.hammurapi.xml.dom.DomSerializable;


/**
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class MetricDomSerializer {

	public DomSerializable toDomSerializable(final Metric metric) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				MetricDomSerializer.this.toDom(holder, metric);
			}
			
		};
	}
	
	/**
	 * @param document
	 * @param holder
	 * @param m
	 * @throws RenderingException
	 */
	private void toDom(Element holder, Metric m) {
		holder.setAttribute("name", m.getName());
        holder.setAttribute("avg", String.valueOf(m.getAvg()));
       	holder.setAttribute("min", String.valueOf(m.getMin()));
		holder.setAttribute("max", String.valueOf(m.getMax()));
		
        holder.setAttribute("total", String.valueOf(m.getTotal()));
        holder.setAttribute("number", String.valueOf(m.getNumber()));
		holder.setAttribute("deviation", String.valueOf(m.getDeviation()));
        
		DOMUtils.toDom(m.getMeasurements(), "measurements", holder);		
	}
}
