/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.metrics;

import java.util.Collection;
import java.util.Iterator;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import biz.hammurapi.metrics.Metric.Measurement;
import biz.hammurapi.render.RenderRequest;
import biz.hammurapi.render.RenderingException;
import biz.hammurapi.render.dom.AbstractRenderer;
import biz.hammurapi.render.dom.DomRenderer;


/**
 * @author Pavel Vlasov
 * @version $Revision: 1.8 $
 */
public class MetricRenderer extends AbstractRenderer implements DomRenderer {
	    
    public MetricRenderer(RenderRequest request) {
        super(request);
    }
    
    public MetricRenderer(RenderRequest request, String profile) {
        super(request, profile);
    }
    
    public Element render(Document document) throws RenderingException {
        Element ret=document.createElement("metric");
        Metric m=(Metric) request.getRenderee();
        
        toDom(ret, m);
        return ret;
	}

	/**
	 * @param document
	 * @param holder
	 * @param m
	 * @throws RenderingException
	 * @throws RenderingException
	 */
	private void toDom(Element holder, Metric m) throws RenderingException {
		holder.setAttribute("name", m.getName());
        holder.setAttribute("avg", String.valueOf(m.getAvg()));
       	holder.setAttribute("min", String.valueOf(m.getMin()));
		holder.setAttribute("max", String.valueOf(m.getMax()));
		
        holder.setAttribute("total", String.valueOf(m.getTotal()));
        holder.setAttribute("number", String.valueOf(m.getNumber()));
		holder.setAttribute("deviation", String.valueOf(m.getDeviation()));
        
        Collection measurements = m.getMeasurements();
		if (measurements!=null) {
	        Iterator it=measurements.iterator();
	        while (it.hasNext()) {
	        	Measurement ms=(Measurement) it.next();
	        	Element me = holder.getOwnerDocument().createElement("measurement");
				holder.appendChild(me);
				renderMeasurement(ms, me);				
	        }
        }
	}

	/**
	 * @param ms
	 * @param me
	 * @throws RenderingException
	 * @throws 
	 * @throws RenderingException
	 * @throws DOMException
	 */
	protected void renderMeasurement(Measurement ms, Element me) throws RenderingException {
		me.setAttribute("value", String.valueOf(ms.getValue()));
		me.setAttribute("time", String.valueOf(ms.getTime()));
	}

}
