/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.metrics;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import biz.hammurapi.render.RenderRequest;
import biz.hammurapi.render.RenderingException;
import biz.hammurapi.render.dom.AbstractRenderer;
import biz.hammurapi.render.dom.DomRenderer;


/**
 * @author Pavel Vlasov
 * @version $Revision: 1.4 $
 */
public class MetricSourceRenderer extends AbstractRenderer implements DomRenderer {
	    
    public MetricSourceRenderer(RenderRequest request) {
        super(request);
    }
    
    public MetricSourceRenderer(RenderRequest request, String profile) {
        super(request, profile);
    }
    
    public Element render(Document document) throws RenderingException {
        Element ret=document.createElement("metrics");                
        MetricSource m=(MetricSource) request.getRenderee();

		LinkedList list = new LinkedList(m.getMetrics().values());
		Collections.sort(list);
		Iterator it=list.iterator();
		while (it.hasNext()) {
			ret.appendChild(new MetricRenderer(new RenderRequest(it.next())).render(document));
		}        
        return ret;
	}
}
