/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz  
 */
package biz.hammurapi.metrics;

import java.rmi.Naming;
import java.rmi.RemoteException;

import biz.hammurapi.config.Component;
import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.DomConfigurable;
import biz.hammurapi.xml.dom.AbstractDomObject;


/**
 * @author Pavel Vlasov
 */
public class RemoteSlicingMeasurementCategoryFactory extends SlicingMeasurementCategoryFactory implements DomConfigurable, Component {    
	private RemoteSliceConsumer remoteSliceConsumer;
    
	/**
	 * @param remoteConsumer
	 */
	public RemoteSlicingMeasurementCategoryFactory(RemoteSliceConsumer remoteConsumer) {
		super();
		this.remoteSliceConsumer = remoteConsumer;
	}
	
	public RemoteSlicingMeasurementCategoryFactory() {
		
	}
	
	protected SliceConsumer createSliceConsumer() throws ConfigurationException {
		try {
	    	if (remoteSliceConsumer==null) {
	    		remoteSliceConsumer=(RemoteSliceConsumer) Naming.lookup(AbstractDomObject.getElementText(configElement, "remote-slice-consumer"));
	    	}
	    	
			return new SliceConsumer() {
				
				String rootCategory=AbstractDomObject.getElementText(configElement, "root-category");
	
				public boolean consumeSlice(String category, Slice slice) {
					try {
						return remoteSliceConsumer.consumeSlice(rootCategory+"."+category, slice);
					} catch (RemoteException e) {
						e.printStackTrace();
						return false;
					}
				}
				
			};
		} catch (Exception e) {
			throw new ConfigurationException(e);
		}
	}
}
