/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.metrics;

import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;

/**
 * Collects metrics in in-memory collection
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class SimpleMeasurementConsumer implements MeasurementConsumer, MetricSource {
	private Map metrics=new HashMap();
	private boolean keepMeasurements;
	
	/**
	 * @param keepMeasurements
	 */
	public SimpleMeasurementConsumer(boolean keepMeasurements) {
		super();
		this.keepMeasurements = keepMeasurements;
	}
	
	/**
	 * 
	 */
	public SimpleMeasurementConsumer() {
		super();
	}
	
	public synchronized void addMeasurement(String name, double value, long time) {
		Metric metric=(Metric) metrics.get(name);
		if (metric==null) {
			metric=new SimpleMetric(name, keepMeasurements);
			metrics.put(name, metric);
		}
		metric.add(value, time);
	}
	
	public Map getMetrics() {
		return metrics;
	}
	
	public String toString() {
		StringBuffer ret=new StringBuffer();
		LinkedList list = new LinkedList(metrics.values());
		Collections.sort(list);
		Iterator it=list.iterator();
		while (it.hasNext()) {
			ret.append(it.next());
			ret.append("\n");
		}
		return ret.toString();
	}
}
