/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz  
 */
package biz.hammurapi.metrics.j2ee;

import java.rmi.RemoteException;
import java.util.Properties;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import biz.hammurapi.config.Component;
import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.DomConfigurable;
import biz.hammurapi.metrics.RemoteSliceConsumer;
import biz.hammurapi.metrics.Slice;
import biz.hammurapi.metrics.SliceConsumer;
import biz.hammurapi.xml.dom.AbstractDomObject;
import biz.hammurapi.xml.dom.DOMUtils;


/**
 * @author Pavel Vlasov
 */
public class JndiSliceConsumer implements SliceConsumer, DomConfigurable, Component {    
    
    private RemoteSliceConsumer remoteConsumer;
	private String root;

	public void start() throws ConfigurationException {
        try {      
    		Properties ctxProps=new Properties();
    		NodeList nl = DOMUtils.selectNodeList(configElement, "environment-property");
    		for (int i=0, l=nl.getLength(); i<l; ++i) {
    			Element e = (Element) nl.item(i);
    			ctxProps.setProperty(e.getAttribute("name"), DOMUtils.getNonBlankElementText(e));
    		}
    		
            InitialContext jndiContext = new InitialContext(ctxProps);
            
            remoteConsumer=(RemoteSliceConsumer) PortableRemoteObject.narrow(jndiContext.lookup(AbstractDomObject.getElementText(configElement, "slice-consumer")), RemoteSliceConsumer.class);            
            root=AbstractDomObject.getElementText(configElement, "root-category");
        } catch (Exception e) {
            throw new ConfigurationException(e);
		}
    }

	public void stop() throws ConfigurationException {
    }
    
	private Element configElement;
    
	public void configure(Node configNode, Context context) throws ConfigurationException {
		configElement=(Element) configNode;
	}

	public boolean consumeSlice(String category, Slice slice) {
		try {
			return remoteConsumer.consumeSlice(root+"."+category, slice);
		} catch (RemoteException e) {
			return false;
		}
	}

	public void setOwner(Object owner) {
		// Ignore		
	}	
}
