package biz.hammurapi.metrics.jmx;

import java.lang.reflect.Method;

import javax.management.MBeanServer;

public class JmxPlatformMeasurementCategoryFactory extends JmxMeasurementCategoryFactory {

	private static MBeanServer MBEAN_SERVER;
	
	// We use reflection to keep hgee.jar compatible with Java 1.4
	static {
		try {
			Class serverClass = Class.forName("java.lang.management.ManagementFactory");
			Method method = serverClass.getMethod("getPlatformMBeanServer", null);
			MBEAN_SERVER = (MBeanServer) method.invoke(null, null);
		} catch (Exception e) {
			System.err.println("[JmxMeasurementCategoryFactory] ERROR: "+e);			
		}
	}

	/**
	 * This implementation tries to use Java 5 management features.
	 * Returns null if JVM is not of version 5.
	 * @return MBean server to register MBeans with
	 */
	protected MBeanServer getMBeanServer() {
		return MBEAN_SERVER;
	}

}
