package biz.hammurapi.metrics.jmx;

import java.util.Date;

/**
 * Interface to expose metrics to JMX.
 * @author Pavel
 */
public interface JmxSlice {

	/**
	 * @return number of measurements
	 */
	int getNumber();
	
	/**
	 * @return Minimum value
	 */
	double getMin();
	
	/**
	 * @return Maximum value
	 */
	double getMax();
	
	/**
	 * @return Average
	 */
	double getAverage();
	
	/**
	 * @return Sum of values from all measurements
	 */
	double getTotal();
	
	/**
	 * @return average distance from average
	 */
	double getDeviation();
	
	/**
	 * @return Slice start time
	 */
	Date getFrom();
	
	/**
	 * @return Slice end time
	 */
	Date getTo();
	
	/**
	 * Clears all collected measurements
	 */
	void reset();
	
}
