/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.metrics.persistent;

import java.io.IOException;
import java.sql.SQLException;
import java.util.HashMap;

import biz.hammurapi.config.MapContext;
import biz.hammurapi.sql.SQLProcessor;
import biz.hammurapi.sql.hypersonic.HypersonicTmpDataSource;


/**
 * @author Pavel Vlasov
 * @version $Revision: 1.1 $
 */
public class HypersonicTmpSliceConsumer extends PersistingSliceConsumer {

    /**
     * @param tick
     * @param keepMeasurements
     * @param maxQueue
     * @param root
     * @throws SQLException
     * @throws IOException
     * @throws ClassNotFoundException
     */
    public HypersonicTmpSliceConsumer (
            String category,
            long history,
            long maintenanceInterval
    ) throws ClassNotFoundException, IOException, SQLException {
        super(category, history, maintenanceInterval, new SQLProcessor(createDataSource(), new MapContext(new HashMap())), null);
        dataSource=(HypersonicTmpDataSource) dstl.get();
    }
    
    private HypersonicTmpDataSource dataSource;
    
    private static ThreadLocal dstl=new ThreadLocal();
    
    private static HypersonicTmpDataSource createDataSource() throws ClassNotFoundException, IOException, SQLException {
        HypersonicTmpDataSource ret = new HypersonicTmpDataSource("com/pavelvlasov/metrics/persistent/HypersonicPersistingSliceConsumer.sql");   
        dstl.set(ret);
        return ret;
    }
    
	public HypersonicTmpDataSource getDataSource() {
		return dataSource;
	}
}
