/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.metrics.persistent;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.StringTokenizer;

import biz.hammurapi.sql.SQLProcessor;

/**
 * Locates metric id by name (path)
 * @author Pavel Vlasov
 * @version $Revision$
 */
public class MetricLocator {
    private MetricsEngine engine;
    
    public MetricLocator(SQLProcessor processor) {
        engine=new MetricsEngine(processor);
    }
    
    MetricLocator(MetricsEngine engine) {
        this.engine=engine;
    }    
    
    public int[] findRoots() throws SQLException {
    	Collection roots=engine.getOrderedRootMetrics(new ArrayList());
    	int[] ret=new int[roots.size()];
    	Iterator it=roots.iterator();
    	for (int i=0; it.hasNext(); i++) {
    		ret[i]=((Number) it.next()).intValue();
    	}
		return ret;
    }
       
    
    public Number find(String category) throws SQLException {
		Number ret=null; 
        if (category!=null) {
        	StringTokenizer st=new StringTokenizer(category, ".");
	        while (st.hasMoreTokens()) {
	            String nextToken = st.nextToken();
				if (ret==null) {
	                ret=engine.getRootMetricId(nextToken);
	            } else {
	                ret=engine.getMetricId(ret.intValue(),nextToken);
	            }
	        	
	        	if (ret==null) {
	                break;
	            }                
	        }
        }
		return ret;
    }
    
    public Number find(int root, String category) throws SQLException {
		Number ret=new Integer(root); 
        if (category!=null) {
        	StringTokenizer st=new StringTokenizer(category, ".");
	        while (st.hasMoreTokens()) {
	            String nextToken = st.nextToken();
				if (ret==null) {
	                ret=engine.getRootMetricId(nextToken);
	            } else {
	                ret=engine.getMetricId(ret.intValue(),nextToken);
	            }
	        	
	        	if (ret==null) {
	                break;
	            }                
	        }
        }
		return ret;        
    }

}
