/**
 * 
 */
package biz.hammurapi.metrics.persistent;

import java.util.Calendar;

import org.jfree.data.time.RegularTimePeriod;

public class SliceTimePeriod extends RegularTimePeriod {

	private Slice slice;
	private SliceTimePeriod previous;
	private SliceTimePeriod next;
	int idx;

	/**
	 * @param slice
	 */
	public SliceTimePeriod(Slice slice, SliceTimePeriod previous) {
		this.slice=slice;
		this.previous=previous;
		if (previous!=null) {
			previous.next=this;
			idx=previous.idx+1;
		}
	}

	public RegularTimePeriod previous() {
		return previous;
	}

	public RegularTimePeriod next() {
		return next;
	}

	public long getSerialIndex() {
		return idx;
	}

	public long getFirstMillisecond(Calendar calendar) {
		return slice.getTimeFrom();
	}

	public long getLastMillisecond(Calendar calendar) {
		return slice.getTimeTo();
	}

	public int compareTo(Object o) {
		if (o instanceof SliceTimePeriod) {
			return idx-((SliceTimePeriod) o).idx;
		} 
					
		return hashCode()-o.hashCode();
	}

	public long getFirstMillisecond() {
		return slice.getTimeFrom();
	}

	public long getLastMillisecond() {
		return slice.getTimeTo();
	}

	public void peg(Calendar calendar) {
		// Not implemented.		
	}
	
}