package biz.hammurapi.remoting;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

public class MapLocalDelegate implements LocalDelegate {
		
	private Map state = new HashMap();


	public Object invoke(Object proxy, Method method, Object[] args, Remoter remoter) throws Throwable {
		Class[] parameterTypes = method.getParameterTypes();
		if (method.getName().length()>3) {
			if (method.getName().startsWith("set") && parameterTypes.length==1 && void.class.equals(method.getReturnType())) {
				state.put(method.getName().substring(3), args[0]);
				return null;
			}
			
			if (method.getName().startsWith("get") && parameterTypes.length==0 && !void.class.equals(method.getReturnType())) {
				return state.get(method.getName().substring(3));
			}
		}
		
		if (Object.class.equals(method.getDeclaringClass())) {
			return method.invoke(state, args);
		}
		
		String[] pt = new String[parameterTypes.length];
		for (int i=0; i<pt.length; ++i) {
			pt[i] = parameterTypes[i].getName();
		}

		return remoter.invoke(new Invocation(state, method.getDeclaringClass().getName(), method.getName(), pt, args, null));
	}


}
