package biz.hammurapi.remoting;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public interface Remoter {

	Object invoke(Invocation invocation) throws Exception;
	
	class ProxyFactory {
		
		public static Object createProxy(Class[] interfaces, final LocalDelegate localDelegate, final Remoter remoter) {
			InvocationHandler ih = new InvocationHandler() {

				public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
					return localDelegate.invoke(proxy, method, args, remoter);
				}
				
			};
			return Proxy.newProxyInstance(ProxyFactory.class.getClassLoader(), interfaces, ih);			
		}
	}
}
