package biz.hammurapi.remoting.http;

import java.io.Serializable;
import java.util.Arrays;

/**
 * Reference for remote invocations over HTTP.
 * @author Pavel
 *
 */
public class HttpReference implements Serializable {
	

	private static int hashCode(Object[] array) {
		final int PRIME = 31;
		if (array == null)
			return 0;
		int result = 1;
		for (int index = 0; index < array.length; index++) {
			result = PRIME * result + (array[index] == null ? 0 : array[index].hashCode());
		}
		return result;
	}

	private String remoteUrl;
	
	private String id;
	
	private String[] interfaces;

	public String[] getInterfaces() {
		return interfaces;
	}

	public String getRemoteUrl() {
		return remoteUrl;
	}
	
	public String getId() {
		return id;
	}

	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
		result = PRIME * result + HttpReference.hashCode(interfaces);
		result = PRIME * result + ((remoteUrl == null) ? 0 : remoteUrl.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final HttpReference other = (HttpReference) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (!Arrays.equals(interfaces, other.interfaces))
			return false;
		if (remoteUrl == null) {
			if (other.remoteUrl != null)
				return false;
		} else if (!remoteUrl.equals(other.remoteUrl))
			return false;
		return true;
	}

	public HttpReference(String remoteUrl, String[] interfaces, String id) {
		super();
		this.remoteUrl = remoteUrl;
		this.interfaces = interfaces;
		this.id = id;
	}
	
	public String toString() {
		StringBuffer ret = new StringBuffer(getClass().getName());
		ret.append(" {");
		ret.append("url=").append(remoteUrl);
		ret.append(";id=").append(id);
		ret.append(";interfaces=");
		for (int i=0; i<interfaces.length; ++i) {
			if (i>0) {
				ret.append(", ");
			}
			ret.append(interfaces[i]);
		}
		ret.append("}");
		return ret.toString();
	}

}
