<xsl:stylesheet 
	version="1.0"  
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:auth="xalan://com.pavelvlasov.authorization.AuthorizationManager"
	xmlns:context="xalan://com.pavelvlasov.util.TransformationContextManager"
>

<xsl:output method="html"/>
<xsl:param name="product.name"/>
<xsl:param name="product.package"/>
<xsl:param name="embedded"/>

    <xsl:template match="/">
        <HTML>
        	<HEAD>        
          	<STYLE> 
	          	<xsl:text disable-output-escaping="yes">
		            <![CDATA[<!-- ]]>
		                TABLE.standard { background:silver }
		                TH.standard { font:bold; background:gray; color:white }
		                TR.standard { background:white }
		                .code-snippet { background-color:EEEEEE; color:blue }
		                .hidden { color:EEEEEE; }
		            <![CDATA[ --> ]]>
	            </xsl:text>
            </STYLE>
          </HEAD>
		      <BODY>
			    	<xsl:if test="/*/element">
			    		<table class="standard">
			    			<tr class="standard">
						    	<xsl:apply-templates select="/*/element[position()=1]/*" mode="column-header"/>
						    	
						    	<xsl:if test="auth:hasClassPermission(/*/element[position()=1]/@type, 'view')">
						    		<th class="standard">View</th>
						    	</xsl:if>
						    </tr>
					    	<xsl:apply-templates select="/*/element"/>
					    </table>					    											    
					    
				    </xsl:if>
					    
				  <xsl:if test="not(/*/element)">
						No data
					</xsl:if>	    
				</BODY>
			</HTML>
    </xsl:template>
    
    <xsl:template match="element">
    		<tr class="standard">
    			<xsl:apply-templates select="*" mode="column"/>
    		</tr>    
    </xsl:template>
    
    <xsl:template match="*" mode="column">
			<td class="standard">
				<xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
				<xsl:value-of select="text()"/>
			</td>		    			
    </xsl:template>
    
    <xsl:template match="*" mode="column-header">
	 		<th class="standard">
	   			<xsl:if test="@label">
	   				<xsl:value-of select="@label"/>
	   			</xsl:if>
	   			
	   			<xsl:if test="not(@label)">
	   				<xsl:value-of select="name()"/>
	   			</xsl:if>
	 		</th>
    </xsl:template>
</xsl:stylesheet>
