<xsl:stylesheet 
	version="1.0"  
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xalan/java"
	xmlns:auth="xalan://com.pavelvlasov.authorization.AuthorizationManager"
	xmlns:context="xalan://com.pavelvlasov.util.TransformationContextManager"
>

<xsl:output method="html"/>
<xsl:param name="product.name"/>
<xsl:param name="product.package"/>
<xsl:param name="embedded"/>

    <xsl:template match="/">
        <HTML>
        	<HEAD>        
          	<STYLE> 
	          	<xsl:text disable-output-escaping="yes">
		            <![CDATA[<!-- ]]>
		                TABLE.standard { background:silver }
		                TH.standard { font:bold; background:gray; color:white }
		                TR.standard { background:white }
		                .code-snippet { background-color:EEEEEE; color:blue }
		                .hidden { color:EEEEEE; }
		            <![CDATA[ --> ]]>
	            </xsl:text>
            </STYLE>
          </HEAD>
		      <BODY>
			      <xsl:for-each select="*">
		        	<table class="standard">
		        		<tr class="standard">
		        			<th class="standard">Field</th>
		        			<th class="standard">Value</th>
		        		</tr>
		        	
			        	<xsl:apply-templates select="*" mode="column"/>
		        	</table>
	    			</xsl:for-each>
	    		</BODY>
	    	</HTML>
    </xsl:template>
    
    <xsl:template match="*" mode="column">
       		<tr class="standard">
        		<td class="standard">
        			<xsl:if test="@label">
        				<xsl:value-of select="@label"/>
        			</xsl:if>
        			
        			<xsl:if test="not(@label)">
        				<xsl:value-of select="name()"/>
        			</xsl:if>
        		</td>
        		
        		<td class="standard">
        			<xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
					<xsl:value-of select="text()"/>
				</td>
        	</tr>
    </xsl:template>

</xsl:stylesheet>
