/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.sql;

import java.sql.ResultSet;
import java.sql.SQLException;

import biz.hammurapi.convert.CompositeConverter;

/**
 * Projects first column by invoking ResultSet.getObject(1)
 * @author Pavel Vlasov
 * @version $Revision: 1.3 $
 */
public class FirstColumnProjector implements Projector {
	
	private Class targetClass;

	public FirstColumnProjector() {
		// Default constructor
	}
	
	public FirstColumnProjector(Class targetClass) {
		this.targetClass=targetClass;
	}

	public Object project(ResultSet rs) throws SQLException {		
		return targetClass==null ? rs.getObject(1) : CompositeConverter.getDefaultConverter().convert(rs.getObject(1), targetClass, false);
	}
}
