/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
  */
package biz.hammurapi.sql;

import java.sql.ResultSet;
import java.sql.SQLException;

import biz.hammurapi.convert.CompositeConverter;
import biz.hammurapi.convert.Converter;

/**
 * Base class for SQLC generated projectors.
 * @author Pavel Vlasov
 *
 * @version $Revision: 1.3 $
 */
public class FirstColumnSmartProjector implements Projector {
    private Converter converter;
	private Class targetClass;

	public Object project(ResultSet rs) throws SQLException {
		Object ret;
		if (targetClass==null) {
			ret = rs.getObject(1);
		} else {
			ret=CompositeConverter.getDefaultConverter().convert(rs.getObject(1), targetClass, false);
		}
		
		if (converter==null) {
			return ret;
		}
		
		return converter.convert(ret);
    }
    
    public FirstColumnSmartProjector(Class targetClass, Converter converter) {
    	this.converter=converter;
    	this.targetClass=targetClass;
    }	    
}
