/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.sql.cloudscape;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.sql.SQLException;

import biz.hammurapi.sql.ConnectionPerThreadDataSource;
import biz.hammurapi.sql.SQLProcessor;
import biz.hammurapi.sql.Transaction;


/**
 * Base class for HyperSonic data sources
 * @author Pavel Vlasov	
 * @version $Revision: 1.2 $
 */
public class CloudscapeDataSource extends ConnectionPerThreadDataSource {


	/**
	 * @param driverClass
	 * @param dbURL
	 * @param user
	 * @param password
	 * @param initConnectionTransaction 
	 * @throws ClassNotFoundException
	 */
	public CloudscapeDataSource(
			String driverClass, 
			String dbURL, 
			String user, 
			String password, 
			Transaction initConnectionTransaction) throws ClassNotFoundException {
		super(driverClass, dbURL, user, password, initConnectionTransaction);
	}
	
	/**
	 * @param scriptName Fully qualified name of a script to execute. E.g. org/hammurapi/results/persistent/jdbc/Hammurapi.Hypersonic.sql
	 * @throws SQLException
	 * @throws IOException
	 */
	public void initDB(String scriptName) throws SQLException, IOException {
		if (scriptName!=null) {
			InputStream in=getClass().getClassLoader().getResourceAsStream(scriptName);
			if (in==null) {
				throw new IOException("Can't load '"+scriptName+"'");
			} else {
				new SQLProcessor(this, null).executeScript(new InputStreamReader(in));
			}
		}
	}
}
