/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.sql.cloudscape;

import biz.hammurapi.sql.Transaction;


/**
 * Hypersonic server data source.
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class CloudscapeServerDataSource extends CloudscapeDataSource {
	
	/**
	 * Connects to remote host specified by host parameter. 
	 * @param host Host string. E.g. 3.111.12.14:3000
	 * @param user User name
	 * @param password Password
	 * @param initConnectionTransaction 
	 * @throws ClassNotFoundException
	 */
	public CloudscapeServerDataSource(
			String host, 
			String database, 
			String user, 
			String password, 
			Transaction initConnectionTransaction) throws ClassNotFoundException {
		super("com.ibm.db2.jcc.DB2Driver", "jdbc:derby:net://"+host+"/"+database, user, password, initConnectionTransaction);
	}	
	
}
