/*
 * hgee 2
 * Hammurapi Group Enterprise Extensions 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/products/enterpriseextensions/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.sql.cloudscape;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;

import biz.hammurapi.sql.Transaction;



/**
 * Hypersonic standalone data source.
 * @author Pavel Vlasov	
 * @version $Revision: 1.2 $
 */
public class CloudscapeStandaloneDataSource extends CloudscapeDataSource {

	/**
	 * Constructor. Creates a database if one doesn't exist.
	 * @param dbName - Database name. E.g. C:\myproject\myDB.
	 * @param initConnectionTransaction 
	 * @throws ClassNotFoundException
	 * @throws IOException
	 * @throws SQLException
	 */
	public CloudscapeStandaloneDataSource(
			String dbName, 
			String user, 
			String password, 
			boolean createDb, 
			Transaction initConnectionTransaction) throws ClassNotFoundException, IOException, SQLException {
		super("org.apache.derby.jdbc.EmbeddedDriver", "jdbc:derby:"+dbName+(createDb ? ";create=true" : ""), user, password, initConnectionTransaction);
		File dbFile=new File(dbName);
		if (!dbFile.exists()) {
			initDB();
		}
	}	
	
	/**
	 * Override this method to automatically initialize database if it does not exist
	 * @throws SQLException
	 */
	protected void initDB() throws SQLException {
		
	}	
}
