/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.sql.xml;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.DomConfigurable;
import biz.hammurapi.config.PropertyParser;
import biz.hammurapi.sql.SQLProcessor;
import biz.hammurapi.xml.dom.AbstractDomObject;


/**
 * @author Pavel Vlasov
 * @version $Revision: 1.4 $
 */
public class Message extends AbstractDomObject implements Command, DomConfigurable {

	private String key;
	private String message;

	public void execute(Element holder, SQLProcessor processor, Context context) throws SQL2XMLException {
		Element me=holder.getOwnerDocument().createElement("message");
		if (key!=null) {
			me.setAttribute("key", key);
		}
		holder.appendChild(me);
		me.appendChild(holder.getOwnerDocument().createTextNode(new PropertyParser(context, false).parse(message)));
	}

	public void configure(Node configNode, Context context)	throws ConfigurationException {
		Element configElement=(Element) configNode;
		if (configElement.hasAttribute("key")) {
			key=configElement.getAttribute("key");
		}

		message=getElementText(configNode);
	}
}
