/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.sql.xml;

import java.sql.SQLException;

import org.w3c.dom.Element;

import biz.hammurapi.config.Context;
import biz.hammurapi.config.PropertyParser;
import biz.hammurapi.sql.SQLProcessor;


/**
 * @author Pavel Vlasov
 * @version $Revision: 1.2 $
 */
public class Update extends SQLCommand implements Command {

	public void execute(Element holder, SQLProcessor processor, final Context context) throws SQL2XMLException {
		if (parameterizer==null || parameterizer.setContext(context)) {
			try {
				int ret=processor.processUpdate(sql, parameterizer);
				Element updateElement=holder.getOwnerDocument().createElement("update");
				if (name!=null) {
					updateElement.setAttribute("name", name);
				}
				
				holder.appendChild(updateElement);
				updateElement.appendChild(holder.getOwnerDocument().createTextNode(String.valueOf(ret)));
			} catch (final SQLException e) {
				throw new SQL2XMLException(
						new PropertyParser(
								new Context() {
									public Object get(String name) {
										if ("error.message".equals(name)) {
											return e.getMessage();
										} else if ("error.class".equals(name)) {
											return e.getClass().getName();
										} else {
											return context.get(name);
										}
									}
								}, false).parse(errorMessage), e);
			}
		}
	}
}
