/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
  */
package biz.hammurapi.swing;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;

import biz.hammurapi.swing.CompositeVisualizer.Member;

/**
 * @author Pavel Vlasov
 *
 * @version $Revision: 1.1 $
 */
public class ArrayVisualizer implements Member {

	private CompositeVisualizer owner;

	public Visualizable toVisualizable(final Object[] oa) {
		return new Visualizable() {

			public MutableTreeNode toTree(final String title) {
				DefaultMutableTreeNode ret=new DefaultMutableTreeNode(oa) {
					public String toString() {
						return title;
					}
				}; 
				
			    for (int i=0; i<oa.length; i++) {				    	
			    	Visualizable ev=owner.getStackHead().toVisualizable(oa[i]);
			    	if (ev!=null) {
			    		ret.add(ev.toTree("element["+i+"]"));
			    	}
			    }			
				
				return ret;
			}

			public TableModel toTable() {
				DefaultTableModel tm=new DefaultTableModel(2,2);
				tm.setColumnIdentifiers(new String[] {"Property", "Value"});
				tm.setValueAt("type", 0, 0);
				tm.setValueAt(oa.getClass().getName(), 0, 1);
				tm.setValueAt("size", 1, 0);
				tm.setValueAt(String.valueOf(oa.length), 1, 1);
				
				return tm;
			}
			
		};
	}

	/**
	 * Callback method
	 */
	public void setOwner(CompositeVisualizer owner) {
		this.owner=owner;
	}
}
