/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.swing;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;

/**
 * @author Pavel Vlasov
 * @revision $Revision: 1.1 $
 */
public class PrimitivesVisualizer {
	private static class PrimitiveVisualizable implements Visualizable {
		Object o;
		
		public PrimitiveVisualizable(Object o) {
			this.o=o;
		}
		
		public MutableTreeNode toTree(final String title) {
			return new DefaultMutableTreeNode(o) {
				public String toString() {
					return title+" ["+o.getClass().getName()+"] "+o;
				}
			}; 
		}

		public TableModel toTable() {
			DefaultTableModel tm=new DefaultTableModel(1,2);
			tm.setColumnIdentifiers(new String[] {"Type", "Value"});
			tm.setValueAt(o.getClass().getName(), 0, 0);
			tm.setValueAt(o, 0, 1);
			
			return tm;
		}
		
	}
	
	
	public Visualizable toVisualizable(final String o) {
		return new PrimitiveVisualizable(o);
	}

	public Visualizable toVisualizable(final Number o) {
		return new PrimitiveVisualizable(o);
	}

	public Visualizable toVisualizable(final Boolean o) {
		return new PrimitiveVisualizable(o);
	}

	public Visualizable toVisualizable(final Character o) {
		return new PrimitiveVisualizable(o);
	}
}
