/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.util;

import java.util.Collection;
import java.util.Iterator;

/**
 * Converts collection into visitable
 * @author Pavel Vlasov
 * @version $Revision: 1.5 $
 */
public class CollectionVisitable implements Visitable {
    private Collection collection;
	private boolean visitCollection;

    public boolean accept(Visitor visitor) {
    	if (visitor==null || collection==null) {
    		return false;
    	}
    	
        if (!visitCollection || visitor.visit(collection)) {
            Iterator it=collection.iterator();
            while (it.hasNext()) {
            	VisitableBase.object2visitor(it.next(), visitor);
            }
            
            if (visitCollection && visitor instanceof PoliteVisitor) {
                ((PoliteVisitor) visitor).leave(collection);
            }
            return true;
        }
        
		return false;
    }
    
    
    /**
     * @param collection
     * @param visitCollection true - visitor visits the collection and its elements; false - only elements
     */
    public CollectionVisitable(Collection collection, boolean visitCollection) {
        super();
        this.collection = collection;
        this.visitCollection=visitCollection;
    }
}
