/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.util;

import java.util.Iterator;
import java.util.Map;

/**
 * Converts collection into visitable
 * @author Pavel Vlasov
 * @version $Revision: 1.3 $
 */
public class MapVisitable implements Visitable {
    private Map map;

    public boolean accept(Visitor visitor) {
    	if (visitor==null || map==null) {
    		return false;
    	}
    	
        if (visitor.visit(map)) {
            Iterator it=map.entrySet().iterator();            
            while (it.hasNext()) {
                Map.Entry entry = (Map.Entry) it.next();
                
                if (visitor.visit(entry)) {       
                	VisitableBase.object2visitor(entry.getKey(), visitor);
                	VisitableBase.object2visitor(entry.getValue(), visitor);
	                
	                if (visitor instanceof PoliteVisitor) {
	                    ((PoliteVisitor) visitor).leave(entry);
	                }
                }
            }
            
            if (visitor instanceof PoliteVisitor) {
                ((PoliteVisitor) visitor).leave(map);
            }
            return true;
        }
        
		return false;
    }
    
    
    public MapVisitable(Map map) {
        super();
        this.map = map;
    }
}
