/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.util;

import java.util.Locale;

/**
 * @author Pavel Vlasov
 * @revision $Revision$
 */
class ResourceKey {
	private String className;
	private String profile;
	private Locale locale;
	private String extension;
	/**
	 * @param className
	 * @param profile
	 * @param locale
	 * @param extension
	 */
	public ResourceKey(String className, String profile, Locale locale,
			String extension) {
		super();
		this.className = className;
		this.profile = profile;
		this.locale = locale;
		this.extension = extension;
	}
	
	public boolean equals(Object otherKey) {
		if (otherKey==this) {
			return true;
		}
		
		if (otherKey instanceof ResourceKey) {
			ResourceKey ork=(ResourceKey) otherKey;
			return className.equals(ork.className) 
				&& (profile==null ? ork.profile==null : profile.equals(ork.profile)) 
				&& (locale==null ? ork.locale==null : locale.equals(ork.locale)) 
				&& (extension==null ? ork.extension==null : extension.equals(ork.extension));
		}
		
		return false;
	}
	
	public int hashCode() {
		return className.hashCode() 
			^ (profile==null ? 0 : profile.hashCode())
			^ (locale==null ? 0 : locale.hashCode())
			^ (extension==null ? 0 : extension.hashCode());
	}
}
