/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.util;

import java.rmi.RemoteException;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.config.RmiComponent;

/**
 * Exposes local worker as remote
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class WorkerRemotizer extends RmiComponent implements RemoteWorker {
	private String masterRef;
	private Worker master;
	
	public WorkerRemotizer() throws RemoteException {
		super();
	}

	public boolean post(Runnable job) {
		return master.post(job);
	}
	
	public void configure(Node configNode, Context context) {
		super.configure(configNode, context);
		Element ce=(Element) configNode;
		if (ce.hasAttribute("worker-ref")) {
			masterRef=ce.getAttribute("worker-ref");
		}
	}
	
	public void start() throws ConfigurationException {
		super.start();
		if (owner instanceof Context) {
			master=(Worker) ((Context) owner).get(masterRef);
		} else {
			throw new ConfigurationException("Cannot lookup master - owner is not a context");
		}
	}

}
