/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.wrap;

import java.lang.ref.Reference;
import java.lang.ref.WeakReference;

/**
 * @author Pavel Vlasov
 * @version $Revision: 1.1 $
 */
public abstract class WeakWrapperHandler extends WrapperHandler {
	private Reference masterRef;
	
	public WeakWrapperHandler(Object master) {
		super(master);
		masterRef=new WeakReference(master);
	}

	protected final Object getMaster() throws Throwable {
		Object master=masterRef.get();
		if (master==null) {
			master=getMasterInternal();
			masterRef=new WeakReference(master);
		}
		return master;
	}

	protected abstract Object getMasterInternal() throws Throwable;
}
