/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */

package biz.hammurapi.xml.dom;

import javax.xml.xpath.XPathExpressionException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import biz.hammurapi.xml.dom.DOMUtils;

/**
 * @author Pavel Vlasov	
 * @version $Revision: 1.4 $
 */
public class AbstractDomObject {

	public static String getElementText(Element root, String child) throws XPathExpressionException {
		Node n=DOMUtils.selectSingleNode(root, child);
		return n==null ? null : getElementText(n);
	}

	/**
	 * @param node
	 * @return Concatenation of all text sub
	 */
	public static String getElementText(Node node) {
		StringBuffer ret=new StringBuffer();
		NodeList childNodes = node.getChildNodes();
		for (int i=0, j=childNodes.getLength(); i<j; i++) {
			Node item = childNodes.item(i);
			if (item instanceof Text) {
				ret.append(item.getNodeValue());
			}
		}
		return ret.toString();
	}
	
	/**
	 * Adds element with text if text is not null.
	 * @param root
	 * @param name
	 * @param text
	 */
	public static Element addTextElement(Element root, String name, String text) {
	    if (text!=null) {
		    Element e=addElement(root, name);
		    e.appendChild(root.getOwnerDocument().createTextNode(text));
		    return e;
	    }
	    return null;
	}
	
	/**
	 * Adds element with specified name.
	 * @param root
	 * @param name
	 * @return
	 */
	public static Element addElement(Node root, String name) {
	    Document doc = root instanceof Document ? (Document) root : root.getOwnerDocument();
	    Element ret=doc.createElement(name);
	    root.appendChild(ret);
	    return ret;
	}
}
