/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
  */
package biz.hammurapi.xml.dom;

import java.util.Iterator;
import java.util.Map;

import org.w3c.dom.Element;

import biz.hammurapi.xml.dom.CompositeDomSerializer.Member;

/**
 * @author Pavel Vlasov
 *
 * @version $Revision: 1.3 $
 */
public class MapDomSerializer implements Member {

	private CompositeDomSerializer owner;

	public DomSerializable toDomSerializable(final Map map) {
		return new DomSerializable() {

			public void toDom(Element holder) {
			    holder.setAttribute("type", map.getClass().getName());
				if (owner!=null) {
				    Iterator it=map.entrySet().iterator();
				    while (it.hasNext()) {
				        Map.Entry entry=(Map.Entry) it.next();
				    	CompositeDomSerializer stackHead = owner.getStackHead();
						DomSerializable kds=stackHead.toDomSerializable(entry.getKey());
				    	DomSerializable vds=stackHead.toDomSerializable(entry.getValue());
				    	
				    	if (kds!=null && vds!=null) {
					        Element ee=holder.getOwnerDocument().createElement("entry");		        
					        holder.appendChild(ee);

					        Element ke=holder.getOwnerDocument().createElement("key");		        
					        ee.appendChild(ke);
					        kds.toDom( ke);
	
					        Element ve=holder.getOwnerDocument().createElement("value");		        
					        ee.appendChild(ve);
					        vds.toDom(ve);
				    	}
				    }
				}
			}
			
		};
	}

	/**
	 * Callback method
	 */
	public void setOwner(CompositeDomSerializer owner) {
		this.owner=owner;
	}
}
