/*
 * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.xml.dom;

import org.w3c.dom.Element;

/**
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class PrimitivesDomSerializer {
	public DomSerializable toDomSerializable(final String o) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				holder.setAttribute("type", o.getClass().getName());
				holder.appendChild(holder.getOwnerDocument().createTextNode(o));
			}
			
		};
	}

	public DomSerializable toDomSerializable(final Number o) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				holder.setAttribute("type", o.getClass().getName());
				holder.appendChild(holder.getOwnerDocument().createTextNode(o.toString()));
			}
			
		};
	}

	public DomSerializable toDomSerializable(final Boolean o) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				holder.setAttribute("type", o.getClass().getName());
				holder.appendChild(holder.getOwnerDocument().createTextNode(o.toString()));
			}
			
		};
	}

	public DomSerializable toDomSerializable(final Character o) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				holder.setAttribute("type", o.getClass().getName());
				holder.appendChild(holder.getOwnerDocument().createTextNode(o.toString()));
			}
			
		};
	}
}
