/*
  * hgcommons 7
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
  */
package biz.hammurapi.xml.dom;

import org.w3c.dom.Element;

/**
 * @author Pavel Vlasov
 *
 * @version $Revision: 1.2 $
 */
public class ThrowableDomSerializer {

	public DomSerializable toDomSerializable(final Throwable th) {
		return new DomSerializable() {

			public void toDom(Element holder) {
				holder.appendChild(holder.getOwnerDocument().createTextNode(th.toString()));
				if (th.getMessage()!=null && th.getMessage().trim().length()>0) {
					holder.setAttribute("message", th.getMessage());
				}
				holder.setAttribute("type", th.getClass().getName());
				holder.setAttribute("is-throwable", "yes");
				StackTraceElement[] st = th.getStackTrace();
			    for (int i=0; i<st.length; i++) {
			    	Element sfe = holder.getOwnerDocument().createElement("stack-frame");
					holder.appendChild(sfe);
					sfe.setAttribute("class", st[i].getClassName());
					sfe.setAttribute("file", st[i].getFileName());
					sfe.setAttribute("method", st[i].getMethodName());
					sfe.setAttribute("line", String.valueOf(st[i].getLineNumber()));
					sfe.setAttribute("native", st[i].isNativeMethod() ? "yes" : "no");
			    }
			    
			    if (th.getCause()!=null) {
			    	Element ce = holder.getOwnerDocument().createElement("cause");
					holder.appendChild(ce);
					toDomSerializable(th.getCause()).toDom(ce);
			    }
			}
			
		};
	}
}
